/* $Id: grabpty.c,v 1.1 1998/08/17 04:53:17 dps Exp $ */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif /* HAVE_SYS_TYPES_H */
#ifdef HAVE_SYS_STAT_H
#include <sys/stat.h>
#endif /* HAVE_SYS_sTAT_H */
#ifdef HAVE_SYS_IOCTL_H
#include <sys/ioctl.h>
#endif /* HAVE_SYS_IOCTL_H */
#ifdef HAVE_TERMIOS_H
#include <termios.h>
#endif /* HAVE_TERMIOS_H */
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif /* HAVE_UNISTD_H */
#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif /* HAVE_FCNTL_H */

#define MAX_PTSNUM 9999

int grabpty(int fd[2], int flg)
{
    const int unlock=0, lock=1;	/* Constants for ioctl */
    int ptynum;			/* slave pty number */
    char name[15];		/* /dev/pts/#### is 14 chars */

    if ((fd[0]=open("/dev/ptmx", O_RDWR))==-1) /* Open master */
	return -1;

    /* Get name of slave */
    if (ioctl(fd[0], TIOCGPTN, &ptynum)==-1)
    {
	close(fd[0]);
	return -1;
    }
    if (ptynum<0 || ptynum>MAX_PTSNUM)
    {
	close(fd[0]);
	return -1;
    }
    sprintf(name, "/dev/pts/%d", ptynum);

    /* unlock and open slave */
    if (ioctl(fd[0], TIOCSPTLCK, &unlock)==-1)
    {
	close(fd[0]);
	return -1;
    }
    if ((fd[1]=open(name, O_RDWR))==-1)
    {
	close(fd[0]);
	return -1;
    }

    /* lock pt */
    if ((ioctl(fd[0], TIOCSPTLCK, &unlock)==-1) && flg)
    {
	close(fd[0]);
	close(fd[1]);
	return -1;
    }

    return 0;
}
