/* $Id: libpt.h,v 1.2 1998/09/06 21:05:43 dps Exp $ */

#ifndef __LIB_PT_H__
#define __LIB_PT_H__ 1

#include <features.h>
#include <ioctl-types.h>
#include <termios.h>

__BEGIN_DECLS

/* Probably standard */
extern int unlockpt __P ((int fd));	   /* Unlock pt */
extern int lockpt __P ((int fd));	   /* Lock pt */
extern const char *ptsname __P ((int fd)); /* Return ptyname in static space */
extern int grantpt __P ((int fd));	   /* Stub: Return 0 */

/* glibc pty.h */
extern int __libpt__openpty __P ((int *__master, int *__slave,
				  const char *__name, struct termios *__termp,
				  struct winsize *__winp));
extern int __libpt__forkpty __P ((int *__master,
				  const char *__name, struct termios *__termp,
				  struct winsize *__winp));

/* #defines */
#define openpty __libpt__openpty
#define forkpty __libpt__forkpty

/* Open a pty with fd[0] as master, fd[1] slave. Re-lock the slave after
 * openning it. If flg is 1 fail if the re-locking operation fails. */
extern int grabpty(int fd[2], int flg);

__END_DECLS

#endif /* __LIB_PT_H__ */
