/* $Id: ptsname.c,v 1.1 1998/08/17 04:53:45 dps Exp $ */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_SYS_IOCTL_H */

#ifdef HAVE_STDIO_H
#include <stdio.h>
#endif /* HAVE_SYS_TYPES_H */
#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif /* HAVE_SYS_TYPES_H */
#ifdef HAVE_SYS_IOCTL_H
#include <sys/ioctl.h>
#endif /* HAVE_SYS_IOCTL_H */
#ifdef HAVE_TERMIOS_H
#include <termios.h>
#endif /* HAVE_TERMIOS_H */
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif /* HAVE_UNISTD_H */


#include <sys/ioctl.h>

#define MAX_PTSNUM 9999

const char *ptsname(int fd)
{
    static char name[15]; /* /dev/pts/####=14 characters */
    int ptnum;

    if (ioctl(fd, TIOCGPTN, &ptnum)==-1)
	return NULL;
    if (ptnum<0 || ptnum>MAX_PTSNUM)
	return NULL;		/* this stops buffer overrun... */
    sprintf(name, "/dev/pts/%d", ptnum); /* /dev/pts/#### fits, so safe */
    return name;
}
